//+------------------------------------------------------------------+
//|                                                        ### 0.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "MFM"
#property link      ""

#property indicator_chart_window

#property indicator_buffers 6
#property indicator_color1 Magenta
#property indicator_color2 Magenta
#property indicator_color3 White
#property indicator_color4 White
#property indicator_color5 Lime
#property indicator_color6 Red


extern int    Width       = 0.5;
extern double Position    = 1;
extern int StartHour = 6;
extern int EndHour = 17;
extern int GMToffset = 0;

double RevUp[];
double RevDown[];
double OBUp[];
double OBDown[];
double IBUp[];
double IBDown[];

static datetime alertTag = D'1980.01.01'; 
static datetime soundTag = D'1980.01.01';
static datetime emailTag = D'1980.01.01';

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
  {
//---- indicators


    SetIndexStyle(0, DRAW_ARROW, EMPTY,Width);
    SetIndexArrow(0, 108);
    SetIndexBuffer(0, RevUp);
    SetIndexStyle(1, DRAW_ARROW, EMPTY,Width);
    SetIndexArrow(1, 108);
    SetIndexBuffer(1, RevDown);
    SetIndexStyle(2, DRAW_ARROW, EMPTY,Width);
    SetIndexArrow(2, 108);
    SetIndexBuffer(2, OBUp);
    SetIndexStyle(3, DRAW_ARROW, EMPTY,Width);
    SetIndexArrow(3, 108);
    SetIndexBuffer(3, OBDown); 
    SetIndexStyle(4, DRAW_ARROW, EMPTY,Width);
    SetIndexArrow(4, 108);
    SetIndexBuffer(4, IBUp);
    SetIndexStyle(5, DRAW_ARROW, EMPTY,Width);
    SetIndexArrow(5, 108);
    SetIndexBuffer(5, IBDown);
     
    
   

//---- 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() 
{
   int limit, i, counter;

   double Range, AvgRange;
   
   int counted_bars=IndicatorCounted();
   
   int  ECN = 1;
    
 if ( Digits == 3 || Digits == 5 ) { ECN = 10; }
 
 
 double ATR   = iATR(NULL,0,20,0)/Point/ECN;  
 
 
Comment("\n","  ATR 20  =  ", iATR(NULL,0,20,0)/Point/ECN);
         
        
//---- check for possible errors

   if(counted_bars<0) return(-1);
   
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;

   limit=Bars-counted_bars;
   
   for(i = 0; i <= limit; i++)
 
   {
   
      counter=i;
      Range=0;
      AvgRange=0;
      for (counter=i ;counter<=i+9;counter++)
      {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      }
      Range=AvgRange/75;
      
      
      // 

      
      
      // IB UP
       
      
      if ( 
         
             High [i] <= High [i+1]
         &&  Low [i] >= Low [i+1]
         &&  Close [i] > Open [i]
         &&  Close [i+1] > Open [i+1]
         //&& TimeHour(Time[i]) >= (StartHour+GMToffset) && TimeHour(Time[i]) < (EndHour+GMToffset)
                                                          
         ) 
      {
         IBUp[i]   = Low[i] - Range*Position;
         IBDown[i] = EMPTY_VALUE;
      }
      
      // IB DOWN
      
      else 
      if (
            
             High [i] <= High [i+1]
         &&  Low [i] >= Low [i+1]
         &&  Close [i] < Open [i]
         &&  Close [i+1] < Open [i+1]
         //&& TimeHour(Time[i]) >= (StartHour+GMToffset) && TimeHour(Time[i]) < (EndHour+GMToffset)
                                                                
         ) 
      {
          IBDown[i] = High[i] + Range*Position;
          IBUp[i]   = EMPTY_VALUE;          
      }
      
      else
      if ( 
         
              High [i] > High [i+1]
         && Low [i] < Low [i+1]
         && Close [i] > Open [i]
         &&  Close [i+1] < Open [i+1]
         //&& TimeHour(Time[i]) >= (StartHour+GMToffset) && TimeHour(Time[i]) < (EndHour+GMToffset)
                                                          
         ) 
      {
         OBUp[i]   = Low[i] - Range*Position;
         OBDown[i] = EMPTY_VALUE;
      }
      
      // 
      
      else 
      if (
            
            High [i] > High [i+1]
         && Low [i] < Low [i+1]
         && Close [i] < Open [i]
         &&  Close [i+1] > Open [i+1]
         //&& TimeHour(Time[i]) >= (StartHour+GMToffset) && TimeHour(Time[i]) < (EndHour+GMToffset)
                                                                
         ) 
      {
          OBDown[i] = High[i] + Range*Position;
          OBUp[i]   = EMPTY_VALUE;          
      }
      
      
      // Any other option
      
      else 
      {
        OBUp[i]   = EMPTY_VALUE;
        OBDown[i] = EMPTY_VALUE;
        IBUp[i]   = EMPTY_VALUE;
        IBDown[i] = EMPTY_VALUE;
        RevUp[i]   = EMPTY_VALUE;
        RevDown[i] = EMPTY_VALUE;        
      }  
      
       }
        }
  
  

 
//END




